----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 19.04.2021 11:26:48
-- Design Name: 
-- Module Name: Test_Etage3_Calcul - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Test_Etage3_Calcul is
--  Port ( );
end Test_Etage3_Calcul;

architecture Behavioral of Test_Etage3_Calcul is
    component Etage3_Calcul is
        Generic ( Nb_bits : Natural;
                  OP_vector_size : Natural;
                  Instruction_bus_size : Natural;
                  Bits_Controle_LC : STD_LOGIC_VECTOR;
                  Bits_Controle_MUX : STD_LOGIC_VECTOR);
        Port ( RST : STD_LOGIC;
               IN_A : in STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               IN_B : in STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               IN_C : in STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               IN_Instruction : in STD_LOGIC_VECTOR (Instruction_bus_size - 1 downto 0);
               OUT_A : out STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               OUT_B : out STD_LOGIC_VECTOR (Nb_bits - 1 downto 0);
               OUT_Instruction : out STD_LOGIC_VECTOR (Instruction_bus_size - 1 downto 0);
               N : out STD_LOGIC;
               O : out STD_LOGIC;
               Z : out STD_LOGIC;
               C : out STD_LOGIC);
    end component;
    
    signal my_RST : STD_LOGIC := '1';
    signal my_IN_A : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_IN_B : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_IN_C : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_IN_Instruction : STD_LOGIC_VECTOR (2 downto 0) := (others => '0');
    signal my_OUT_A : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_OUT_B : STD_LOGIC_VECTOR (7 downto 0) := (others => '0');
    signal my_OUT_Instruction : STD_LOGIC_VECTOR (2 downto 0) := (others => '0');
    signal my_N : STD_LOGIC;
    signal my_O : STD_LOGIC;
    signal my_Z : STD_LOGIC;
    signal my_C : STD_LOGIC;
    
    constant Bits_Controle_LC : STD_LOGIC_VECTOR (15 downto 0) := x"00b4";
    constant Bits_Controle_MUX : STD_LOGIC_VECTOR (7 downto 0) := "11110001";
    
begin

    instance : Etage3_Calcul
    generic map( Nb_bits => 8,
                 OP_vector_size => 2,
                 Instruction_bus_size => 3,
                 Bits_Controle_LC => Bits_Controle_LC,
                 Bits_Controle_MUX => Bits_Controle_MUX)
    port map(    RST => my_RST,
                 IN_A => my_IN_A,
                 IN_B => my_IN_B,
                 IN_C => my_IN_C,
                 IN_Instruction => my_IN_Instruction,
                 OUT_A => my_OUT_A,
                 OUT_B => my_OUT_B,
                 OUT_Instruction => my_OUT_Instruction,
                 N => my_N,
                 O => my_O,
                 Z => my_Z,
                 C => my_C);
    
    process 
    begin     
        my_IN_A <= "01011111";
        my_IN_B <= "10100110";
        my_IN_C <= "01101101";
        my_IN_Instruction <= "000" after 0 ns, "001" after 10 ns, "010" after 20 ns, "011" after 30 ns, "100" after 40 ns, "101" after 50 ns, "110" after 60 ns, "111" after 70 ns, "000" after 80 ns;
        my_RST <= '0' after 45 ns;
        wait;
    end process;    
end Behavioral;
